// HscDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Kniffel.h"
#include "HscDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CHscDlg 


CHscDlg::CHscDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHscDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHscDlg)
	m_sP1 = _T("");
	m_sP10 = _T("");
	m_sP3 = _T("");
	m_sP2 = _T("");
	m_sP4 = _T("");
	m_sP5 = _T("");
	m_sP6 = _T("");
	m_sP7 = _T("");
	m_sP8 = _T("");
	m_sP9 = _T("");
	m_sEname1 = _T("");
	m_sEname10 = _T("");
	m_sEname2 = _T("");
	m_sEname3 = _T("");
	m_sEname4 = _T("");
	m_sEname5 = _T("");
	m_sEname6 = _T("");
	m_sEname7 = _T("");
	m_sEname8 = _T("");
	m_sEname9 = _T("");
	//}}AFX_DATA_INIT
}

void CHscDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHscDlg)
	DDX_Text(pDX, IDC_P1, m_sP1);
	DDX_Text(pDX, IDC_P10, m_sP10);
	DDX_Text(pDX, IDC_P3, m_sP3);
	DDX_Text(pDX, IDC_P2, m_sP2);
	DDX_Text(pDX, IDC_P4, m_sP4);
	DDX_Text(pDX, IDC_P5, m_sP5);
	DDX_Text(pDX, IDC_P6, m_sP6);
	DDX_Text(pDX, IDC_P7, m_sP7);
	DDX_Text(pDX, IDC_P8, m_sP8);
	DDX_Text(pDX, IDC_P9, m_sP9);
	DDX_Text(pDX, IDC_ENAME1, m_sEname1);
	DDX_Text(pDX, IDC_ENAME10, m_sEname10);
	DDX_Text(pDX, IDC_ENAME2, m_sEname2);
	DDX_Text(pDX, IDC_ENAME3, m_sEname3);
	DDX_Text(pDX, IDC_ENAME4, m_sEname4);
	DDX_Text(pDX, IDC_ENAME5, m_sEname5);
	DDX_Text(pDX, IDC_ENAME6, m_sEname6);
	DDX_Text(pDX, IDC_ENAME7, m_sEname7);
	DDX_Text(pDX, IDC_ENAME8, m_sEname8);
	DDX_Text(pDX, IDC_ENAME9, m_sEname9);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CHscDlg, CDialog)
	//{{AFX_MSG_MAP(CHscDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CHscDlg 

void CHscDlg::Daten_Auslesen()
{
	int i;
	char spname[35];
	bool betrug=false;
	
	CString strSektion;
	CString strPfad = strProgrammPfad +"\\HScore.knf";
	
	for(i=0; i<=9; i++)
	{
		strSektion.Format("%d",i+1);
		iPunkte[i] = GetPrivateProfileInt(strSektion,"Punkte",0,strPfad);
		GetPrivateProfileString(strSektion,"Name","NULL",spname,sizeof(spname),strPfad);
		sSpielername[i].Format("%s",spname);
		if (sSpielername[i]=="NULL")sSpielername[i]="";
		// Betrugsversuche abfangen
		if (iPunkte[i]>375)
		{
			iPunkte[i]=0;
			sSpielername[i]="";
			betrug=true;
		}
	}	
	if (betrug)
	{
		Daten_Sortieren();
		Daten_Schreiben();
		Daten_Auslesen();
	}
}

void CHscDlg::Daten_Schreiben()
{
	int i;
	CString strSektion;
	CString strPfad = strProgrammPfad +"\\HScore.knf";
	CString sPunkte = "";
	
	for(i=0; i<=9; i++)
	{
		strSektion.Format("%d",i+1);
		WritePrivateProfileString(strSektion,"Name",sSpielername[i],strPfad);
		sPunkte.Format("%d",iPunkte[i]);
		WritePrivateProfileString(strSektion,"Punkte",sPunkte,strPfad);
	}		
}


void CHscDlg::Daten_Anzeigen()
{
	m_sP1.Format("%d",iPunkte[0]);
	m_sP2.Format("%d",iPunkte[1]);
	m_sP3.Format("%d",iPunkte[2]);
	m_sP4.Format("%d",iPunkte[3]);
	m_sP5.Format("%d",iPunkte[4]);
	m_sP6.Format("%d",iPunkte[5]);
	m_sP7.Format("%d",iPunkte[6]);
	m_sP8.Format("%d",iPunkte[7]);
	m_sP9.Format("%d",iPunkte[8]);
	m_sP10.Format("%d",iPunkte[9]);
	m_sEname1 = sSpielername[0];
	m_sEname2 = sSpielername[1];
	m_sEname3 = sSpielername[2];
	m_sEname4 = sSpielername[3];
	m_sEname5 = sSpielername[4];
	m_sEname6 = sSpielername[5];
	m_sEname7 = sSpielername[6];
	m_sEname8 = sSpielername[7];
	m_sEname9 = sSpielername[8];
	m_sEname10 = sSpielername[9];
	UpdateData(false);
}

void CHscDlg::Programmpfad_ermitteln()
{
	char *apppath;
	int i;

	apppath=(char *)malloc(256);
	GetModuleFileName(NULL,apppath, 256);	// Pfad + File
	i=strlen(apppath);
	while (i>1)
	{
		if (apppath[i]=='\\')
		{
			apppath[i]='\0';
			i=0;
		}
	i--;
	}
	strProgrammPfad.Format("%s",apppath);
}

void CHscDlg::Daten_Uebernehmen()
{
	UpdateData(true);
	iPunkte[0] = strtol(m_sP1,NULL,10);
	iPunkte[1] = strtol(m_sP2,NULL,10);
	iPunkte[2] = strtol(m_sP3,NULL,10);
	iPunkte[3] = strtol(m_sP4,NULL,10);
	iPunkte[4] = strtol(m_sP5,NULL,10);
	iPunkte[5] = strtol(m_sP6,NULL,10);
	iPunkte[6] = strtol(m_sP7,NULL,10);
	iPunkte[7] = strtol(m_sP8,NULL,10);
	iPunkte[8] = strtol(m_sP9,NULL,10);
	iPunkte[9] = strtol(m_sP10,NULL,10);
	sSpielername[0] = m_sEname1;
	sSpielername[1] = m_sEname2;
	sSpielername[2] = m_sEname3;
	sSpielername[3] = m_sEname4;
	sSpielername[4] = m_sEname5;
	sSpielername[5] = m_sEname6;
	sSpielername[6] = m_sEname7;
	sSpielername[7] = m_sEname8;
	sSpielername[8] = m_sEname9;
	sSpielername[9] = m_sEname10;
}

BOOL CHscDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Zustzliche Initialisierung hier einfgen
	int i=0;

	Programmpfad_ermitteln();
	Daten_Auslesen();

	bDaten_geaendert = false;

	if (bPunktePruefen)
	{
		if (iAktuellePunktzahl > iPunkte[9])
		{
			bDaten_geaendert = true;
		}
		else
		{
			CString sPunkte;
			sPunkte.Format("%d",iAktuellePunktzahl);
			MessageBox("Ihre Punktezahl von: "+sPunkte+"\nwar zu niedrig fr die Bestenliste",
				"Zu wenig Punkte!",MB_OK+MB_ICONINFORMATION);
		}
	}

	Daten_Sortieren();
	Daten_Anzeigen();

	if (bDaten_geaendert)	// Name in High Score eintragen lassen
	{
		for (i=0; i<=9; i++)
		{
			if (iPunkte[i] == iAktuellePunktzahl)
			{
				if ((iPunkte[i+1] == iAktuellePunktzahl)&&(i<9))i++;
				if ((iPunkte[i+1] == iAktuellePunktzahl)&&(i<9))i++;
				GetDlgItem(IDC_ENAME1+i)->EnableWindow(true);
				GetDlgItem(IDC_ENAME1+i)->SetFocus();
				i=10;
			}
		}
	}


	// Zufllig ein Icon zuweisen
	i = (rand()%6);
	SetIcon( m_hZufallsIcon[i], TRUE);
	SetIcon( m_hZufallsIcon[i], FALSE);

	return !bDaten_geaendert;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CHscDlg::Daten_Sortieren()
{
	int i;
	int iPunkteTmp[11];
	int iRangTmp[11];
	CString sNameTmp[11];
	int tmpP;
	int	tmpR;
	int j;
	
	// Werte in eine Variable zum sortieren speichern
	for (i=0; i <=9; i++)
	{
		iPunkteTmp[i] = iPunkte[i];
		iRangTmp[i]=i+1;
		sNameTmp[i]= sSpielername[i];
	}
	iPunkteTmp[10] = iAktuellePunktzahl;
	iRangTmp[10] = 11;
	sNameTmp[10] = "";
	
	// Grte Punktzahl ganz vorne (Sortieren)
	for (j=9; j!=-1; j--)
	{
		for (i=0; i<=j; i++)
		{
			if (iPunkteTmp[i] < iPunkteTmp[i+1])
			{	// Punkte sortieren
				tmpP = iPunkteTmp[i+1];
				iPunkteTmp [i+1] = iPunkteTmp[i];
				iPunkteTmp [i] = tmpP;
				// ehemaligen Rang zwischenspeichern
				tmpR = iRangTmp[i+1];
				iRangTmp [i+1] = iRangTmp[i];
				iRangTmp [i] = tmpR;
			}
		}
	}

	// Werte sortiert zurckschreiben in Ausgangsvariable
	for (i=0; i <=9; i++)
	{
		 iPunkte[i] = iPunkteTmp[i];
		 sSpielername[i] = sNameTmp[iRangTmp[i]-1];
	}
}

void CHscDlg::OnOK() 
{
	// TODO: Zustzliche Prfung hier einfgen
	
	if (bDaten_geaendert)
	{
		Daten_Uebernehmen();
		Daten_Schreiben();
	}

	CDialog::OnOK();
}
