// KniffelDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "Kniffel.h"
#include "KniffelDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKniffelDlg Dialogfeld

CKniffelDlg::CKniffelDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CKniffelDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CKniffelDlg)
	m_i1er = 0;
	m_i2er = 0;
	m_i3er = 0;
	m_i3pash = 0;
	m_i4er = 0;
	m_i4pash = 0;
	m_i5er = 0;
	m_i6er = 0;
	m_iBonus = 0;
	m_iChance = 0;
	m_iFullhouse = 0;
	m_iGesamt = 0;
	m_iGstreet = 0;
	m_iKniffel = 0;
	m_iKstreet = 0;
	m_iOben = 0;
	m_iUnten = 0;
	m_bWh1 = FALSE;
	m_bWh2 = FALSE;
	m_bWh3 = FALSE;
	m_bWh4 = FALSE;
	m_bWh5 = FALSE;
	m_bSphilfe = FALSE;
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDI_6);
}

void CKniffelDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CKniffelDlg)
	DDX_Text(pDX, IDC_E1ER, m_i1er);
	DDV_MinMaxByte(pDX, m_i1er, 0, 5);
	DDX_Text(pDX, IDC_E2ER, m_i2er);
	DDV_MinMaxByte(pDX, m_i2er, 0, 10);
	DDX_Text(pDX, IDC_E3ER, m_i3er);
	DDV_MinMaxByte(pDX, m_i3er, 0, 15);
	DDX_Text(pDX, IDC_E3PASH, m_i3pash);
	DDV_MinMaxByte(pDX, m_i3pash, 0, 30);
	DDX_Text(pDX, IDC_E4ER, m_i4er);
	DDV_MinMaxByte(pDX, m_i4er, 0, 20);
	DDX_Text(pDX, IDC_E4PASH, m_i4pash);
	DDV_MinMaxByte(pDX, m_i4pash, 0, 30);
	DDX_Text(pDX, IDC_E5ER, m_i5er);
	DDV_MinMaxByte(pDX, m_i5er, 0, 25);
	DDX_Text(pDX, IDC_E6ER, m_i6er);
	DDV_MinMaxByte(pDX, m_i6er, 0, 30);
	DDX_Text(pDX, IDC_EBONUS, m_iBonus);
	DDV_MinMaxByte(pDX, m_iBonus, 0, 35);
	DDX_Text(pDX, IDC_ECHANCE, m_iChance);
	DDV_MinMaxByte(pDX, m_iChance, 0, 30);
	DDX_Text(pDX, IDC_EFULLHOUSE, m_iFullhouse);
	DDV_MinMaxByte(pDX, m_iFullhouse, 0, 25);
	DDX_Text(pDX, IDC_EGESAMT, m_iGesamt);
	DDV_MinMaxInt(pDX, m_iGesamt, 0, 375);
	DDX_Text(pDX, IDC_EGSTREET, m_iGstreet);
	DDV_MinMaxByte(pDX, m_iGstreet, 0, 40);
	DDX_Text(pDX, IDC_EKNIFFEL, m_iKniffel);
	DDV_MinMaxByte(pDX, m_iKniffel, 0, 50);
	DDX_Text(pDX, IDC_EKSTREET, m_iKstreet);
	DDV_MinMaxByte(pDX, m_iKstreet, 0, 30);
	DDX_Text(pDX, IDC_EOBEN, m_iOben);
	DDV_MinMaxByte(pDX, m_iOben, 0, 105);
	DDX_Text(pDX, IDC_EUNTEN, m_iUnten);
	DDV_MinMaxByte(pDX, m_iUnten, 0, 255);
	DDX_Check(pDX, IDC_WH1, m_bWh1);
	DDX_Check(pDX, IDC_WH2, m_bWh2);
	DDX_Check(pDX, IDC_WH3, m_bWh3);
	DDX_Check(pDX, IDC_WH4, m_bWh4);
	DDX_Check(pDX, IDC_WH5, m_bWh5);
	DDX_Check(pDX, IDC_SPHILFE, m_bSphilfe);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CKniffelDlg, CDialog)
	//{{AFX_MSG_MAP(CKniffelDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	ON_BN_CLICKED(IDC_HSC, OnHsc)
	ON_BN_CLICKED(IDC_SPHILFE, OnSphilfe)
	ON_BN_CLICKED(IDC_NEWGAME, OnNewgame)
	ON_BN_CLICKED(IDC_1ER, On1er)
	ON_BN_CLICKED(IDC_2ER, On2er)
	ON_BN_CLICKED(IDC_3ER, On3er)
	ON_BN_CLICKED(IDC_4ER, On4er)
	ON_BN_CLICKED(IDC_5ER, On5er)
	ON_BN_CLICKED(IDC_6ER, On6er)
	ON_BN_CLICKED(IDC_3PASH, On3pash)
	ON_BN_CLICKED(IDC_4PASH, On4pash)
	ON_BN_CLICKED(IDC_FULLHOUSE, OnFullhouse)
	ON_BN_CLICKED(IDC_KSTREET, OnKstreet)
	ON_BN_CLICKED(IDC_GSTREET, OnGstreet)
	ON_BN_CLICKED(IDC_KNIFFEL, OnKniffel)
	ON_BN_CLICKED(IDC_CHANCE, OnChance)
	ON_BN_CLICKED(IDC_WH1, OnWh)
	ON_BN_CLICKED(IDC_WH2, OnWh)
	ON_BN_CLICKED(IDC_WH3, OnWh)
	ON_BN_CLICKED(IDC_WH4, OnWh)
	ON_BN_CLICKED(IDC_WH5, OnWh)
	ON_BN_CLICKED(IDC_WUERFELN, OnWuerfeln)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKniffelDlg Nachrichten-Handler

BOOL CKniffelDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen
	
	// Wrfelbilder laden
	BYTE i = 0;
	for (i=0;i<=6;i++)
	{
		m_bmpW[i].LoadBitmap(IDB_0+i);
		m_icoZahl[i] = AfxGetApp()->LoadIcon(IDI_0-i);
	}

	// Wrfelbilder fr Highscore Liste
	for (i=0;i<=5;i++)
	{
		m_dlgHsc.m_hZufallsIcon[i] = m_icoZahl[i+1];
	}

	// Zufallszahlen-Generator Initialisieren
	srand(time(NULL));	

	// Wrfel auf Null setzten
	iWuerfel[0] = 0;
	iWuerfel[1] = 0;
	iWuerfel[2] = 0;
	iWuerfel[3] = 0;
	iWuerfel[4] = 0;

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CKniffelDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CKniffelDlg::OnPaint() 
{
	CPaintDC dc(this);	// Gertekontext fr Zeichnen
	if (IsIconic())
	{
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		Wuerfel_anzeigen(&dc);
		if (m_bSphilfe) SPHilfe_anzeigen(&dc);
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CKniffelDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CKniffelDlg::OnExit() 
{
	CDialog::OnOK();
}

void CKniffelDlg::OnHsc() 
{
	m_dlgHsc.iAktuellePunktzahl = 0;
	m_dlgHsc.bPunktePruefen = false;
	m_dlgHsc.DoModal();
}

void CKniffelDlg::OnSphilfe() 
{
	int i=0;
	UpdateData(true);
	if (m_bSphilfe)
	{
		SetDlgItemText(IDC_SPHILFE,"Spielhilfe ausschalten");
		
		for (i=0;i<=12;i++)
		{
			if (m_bTaste[i])GetDlgItem(IDC_E1ER + i)->ShowWindow(false);
		}
	}
	else
	{
		SetDlgItemText(IDC_SPHILFE,"Spielhilfe einschalten");
		
		//alle Ergebnissfelder einblenden
		for (i=0;i<=12;i++)
		{
			GetDlgItem(IDC_E1ER + i)->ShowWindow(true);
		}
	}
	Invalidate();
}

void CKniffelDlg::OnNewgame() 
{
int i;

	// Schaltflschen freigeben
	GetDlgItem(IDC_WUERFELN)->EnableWindow(true);
	GetDlgItem(IDC_1ER)->EnableWindow(true);
	GetDlgItem(IDC_2ER)->EnableWindow(true);
	GetDlgItem(IDC_3ER)->EnableWindow(true);
	GetDlgItem(IDC_4ER)->EnableWindow(true);
	GetDlgItem(IDC_5ER)->EnableWindow(true);
	GetDlgItem(IDC_6ER)->EnableWindow(true);
	GetDlgItem(IDC_E1ER)->EnableWindow(true);
	GetDlgItem(IDC_E2ER)->EnableWindow(true);
	GetDlgItem(IDC_E3ER)->EnableWindow(true);
	GetDlgItem(IDC_E4ER)->EnableWindow(true);
	GetDlgItem(IDC_E5ER)->EnableWindow(true);
	GetDlgItem(IDC_E6ER)->EnableWindow(true);
	GetDlgItem(IDC_EOBEN)->EnableWindow(true);
	GetDlgItem(IDC_EBONUS)->EnableWindow(true);
	GetDlgItem(IDC_TOBEN)->EnableWindow(true);
	GetDlgItem(IDC_TBONUS)->EnableWindow(true);
	GetDlgItem(IDC_3PASH)->EnableWindow(true);
	GetDlgItem(IDC_4PASH)->EnableWindow(true);
	GetDlgItem(IDC_FULLHOUSE)->EnableWindow(true);
	GetDlgItem(IDC_KSTREET)->EnableWindow(true);
	GetDlgItem(IDC_GSTREET)->EnableWindow(true);
	GetDlgItem(IDC_KNIFFEL)->EnableWindow(true);
	GetDlgItem(IDC_CHANCE)->EnableWindow(true);
	GetDlgItem(IDC_E3PASH)->EnableWindow(true);
	GetDlgItem(IDC_E4PASH)->EnableWindow(true);
	GetDlgItem(IDC_EFULLHOUSE)->EnableWindow(true);
	GetDlgItem(IDC_EKSTREET)->EnableWindow(true);
	GetDlgItem(IDC_EGSTREET)->EnableWindow(true);
	GetDlgItem(IDC_EKNIFFEL)->EnableWindow(true);
	GetDlgItem(IDC_ECHANCE)->EnableWindow(true);
	GetDlgItem(IDC_EUNTEN)->EnableWindow(true);
	GetDlgItem(IDC_EGESAMT)->EnableWindow(true);
	GetDlgItem(IDC_TUNTEN)->EnableWindow(true);
	GetDlgItem(IDC_TGESAMT)->EnableWindow(true);
	GetDlgItem(IDC_WH1)->EnableWindow(true);
	GetDlgItem(IDC_WH2)->EnableWindow(true);
	GetDlgItem(IDC_WH3)->EnableWindow(true);
	GetDlgItem(IDC_WH4)->EnableWindow(true);
	GetDlgItem(IDC_WH5)->EnableWindow(true);
	GetDlgItem(IDC_SPHILFE)->EnableWindow(true);

	// Schaltflschenfreigabe Speichern fr Spielhilfe
	for (i=0; i<13;i++)
	{
		m_bTaste[i]=true;
	}

	// Anzahl des Wurfes und des Durchganges auf 0 setzten
	iWurf = 0;
	iDurchgang = 0;

	// Wrfel auf 0 und anzeigen
	for (i=0; i <= 4; i++)
	{
		iWuerfel[i] = 0;
	}
	// Wuerfel anzeigen
	Invalidate();

	// Punkte zurcksetzten
	m_i1er = 0;
	m_i2er = 0;
	m_i3er = 0;
	m_i4er = 0;
	m_i5er = 0;
	m_i6er = 0;
	m_iOben = 0;
	m_iBonus = 0;
	m_i3pash = 0;
	m_i4pash = 0;
	m_iFullhouse = 0;
	m_iKstreet = 0;
	m_iGstreet = 0;
	m_iKniffel = 0;
	m_iChance = 0;
	m_iUnten = 0;
	m_iGesamt = 0;
	

	// Steuerfelder zurcksetzen
	m_bWh1 = false;
	m_bWh2 = false;
	m_bWh3 = false;
	m_bWh4 = false;
	m_bWh5 = false;
	UpdateData(false);
	OnWh();
	OnSphilfe();
	GetDlgItem(IDC_WH1)->EnableWindow(false);
	GetDlgItem(IDC_WH2)->EnableWindow(false);
	GetDlgItem(IDC_WH3)->EnableWindow(false);
	GetDlgItem(IDC_WH4)->EnableWindow(false);
	GetDlgItem(IDC_WH5)->EnableWindow(false);


	// Zufllig ein Icon fr den Dialog setzten
	i = 1+(rand()%6);
	SetIcon(m_icoZahl[i], TRUE);
	SetIcon(m_icoZahl[i], FALSE);
}
	
void CKniffelDlg::On1er() 
{
	m_i1er = p1erbis6er(1);
		GetDlgItem(IDC_1ER)->EnableWindow(false);
	GetDlgItem(IDC_E1ER)->ShowWindow(true);
	m_bTaste[0]=false;
	PunkteAuszaehlen();
}

void CKniffelDlg::On2er() 
{
	m_i2er = p1erbis6er(2);
	PunkteAuszaehlen();
	GetDlgItem(IDC_2ER)->EnableWindow(false);
	GetDlgItem(IDC_E2ER)->ShowWindow(true);
	m_bTaste[1]=false;
}

void CKniffelDlg::On3er() 
{
	m_i3er = p1erbis6er(3);
	GetDlgItem(IDC_3ER)->EnableWindow(false);
	GetDlgItem(IDC_E3ER)->ShowWindow(true);
	m_bTaste[2]=false;
	PunkteAuszaehlen();
}

void CKniffelDlg::On4er() 
{
	m_i4er = p1erbis6er(4);
	GetDlgItem(IDC_4ER)->EnableWindow(false);
	GetDlgItem(IDC_E4ER)->ShowWindow(true);
	m_bTaste[3]=false;
	PunkteAuszaehlen();
}

void CKniffelDlg::On5er() 
{
	m_i5er = p1erbis6er(5);
	GetDlgItem(IDC_5ER)->EnableWindow(false);
	GetDlgItem(IDC_E5ER)->ShowWindow(true);
	m_bTaste[4]=false;
	PunkteAuszaehlen();
}

void CKniffelDlg::On6er() 
{
	m_i6er = p1erbis6er(6);
	GetDlgItem(IDC_6ER)->EnableWindow(false);
	GetDlgItem(IDC_E6ER)->ShowWindow(true);
	m_bTaste[5]=false;
	PunkteAuszaehlen();
}

void CKniffelDlg::On3pash() 
{
	m_i3pash = pPash(3);
	GetDlgItem(IDC_3PASH)->EnableWindow(false);
	GetDlgItem(IDC_E3PASH)->ShowWindow(true);
	m_bTaste[6]=false;
	PunkteAuszaehlen();
}

void CKniffelDlg::On4pash() 
{
	m_i4pash = pPash(4);
	GetDlgItem(IDC_4PASH)->EnableWindow(false);
	GetDlgItem(IDC_E4PASH)->ShowWindow(true);
	m_bTaste[7]=false;
	PunkteAuszaehlen();
}

void CKniffelDlg::OnFullhouse() 
{
	m_iFullhouse = pFullhouse();
	GetDlgItem(IDC_FULLHOUSE)->EnableWindow(false);
	GetDlgItem(IDC_EFULLHOUSE)->ShowWindow(true);
	m_bTaste[8]=false;
	PunkteAuszaehlen();
}

void CKniffelDlg::OnKstreet() 
{
	m_iKstreet = pKstreet();
	GetDlgItem(IDC_KSTREET)->EnableWindow(false);
	GetDlgItem(IDC_EKSTREET)->ShowWindow(true);
	m_bTaste[9]=false;
	PunkteAuszaehlen();
}

void CKniffelDlg::OnGstreet() 
{
	m_iGstreet = pGstreet();
	GetDlgItem(IDC_GSTREET)->EnableWindow(false);
	GetDlgItem(IDC_EGSTREET)->ShowWindow(true);
	m_bTaste[10]=false;
	PunkteAuszaehlen();
}

void CKniffelDlg::OnKniffel() 
{
	m_iKniffel = pPash(5);
	GetDlgItem(IDC_KNIFFEL)->EnableWindow(false);
	GetDlgItem(IDC_EKNIFFEL)->ShowWindow(true);
	m_bTaste[11]=false;
	PunkteAuszaehlen();
}

void CKniffelDlg::OnChance() 
{
	m_iChance = pChance();
	GetDlgItem(IDC_CHANCE)->EnableWindow(false);
	GetDlgItem(IDC_ECHANCE)->ShowWindow(true);
	m_bTaste[12]=false;
	PunkteAuszaehlen();
}


void CKniffelDlg::OnWh() 
{
	UpdateData(true);
	bWh[0] = m_bWh1;
	bWh[1] = m_bWh2;
	bWh[2] = m_bWh3;
	bWh[3] = m_bWh4;
	bWh[4] = m_bWh5;
}

void CKniffelDlg::PunkteAuszaehlen()
{
	BYTE i = 0;

	// Daten Aktualisieren
	UpdateData(false);
	UpdateData(true);

	// Zusammenzhlen
	m_iOben = m_i1er + m_i2er + m_i3er + m_i4er + m_i5er + m_i6er;
	if (m_iOben >= 63) m_iBonus = 35;
	m_iUnten = m_i3pash + m_i4pash + m_iFullhouse + m_iKstreet + m_iGstreet + m_iKniffel + m_iChance;
	m_iGesamt = m_iOben + m_iUnten + m_iBonus;

	// Steuerfelder zurcksetzen
	m_bWh1 = false;
	m_bWh2 = false;
	m_bWh3 = false;
	m_bWh4 = false;
	m_bWh5 = false;
	GetDlgItem(IDC_WUERFELN)->EnableWindow(true);
	GetDlgItem(IDC_WH1)->EnableWindow(false);
	GetDlgItem(IDC_WH2)->EnableWindow(false);
	GetDlgItem(IDC_WH3)->EnableWindow(false);
	GetDlgItem(IDC_WH4)->EnableWindow(false);
	GetDlgItem(IDC_WH5)->EnableWindow(false);

	// Durchgang erhhen
	iDurchgang++;

	// Wurf zurcksetzten
	iWurf = 0;

	// Neue Daten anzeigen
	UpdateData(false);

	// Wrfel zurcksetzen und anzeigen
	for (i=0; i<=4; i++)
	{
		iWuerfel[i] = 0;
	}
	Invalidate();
	
	if (iDurchgang == 13)
	{
		GetDlgItem(IDC_NEWGAME)->SetFocus();
		GetDlgItem(IDC_SPHILFE)->EnableWindow(false);
		GetDlgItem(IDC_WUERFELN)->EnableWindow(false);
		
		m_dlgHsc.iAktuellePunktzahl = m_iGesamt;
		m_dlgHsc.bPunktePruefen = true;
		m_dlgHsc.DoModal();
		
	}
	else
	{
		// Focus auf 'Wrfeln' setzen
		GetDlgItem(IDC_WUERFELN)->SetFocus();
	}
}

void CKniffelDlg::WOrdnen(BYTE &riW1, BYTE &riW2, BYTE &riW3, BYTE &riW4, BYTE &riW5)
{
	// & ... Variablen als Referenz bergeben (ndert die den Wert der bergeben Variable)
	BYTE i;
	BYTE iTmp[6];
	BYTE t;
	BYTE j;
	
	// Werte in eine Variable zum sortieren speichern
	iTmp[0] = riW1;
	iTmp[1] = riW2;
	iTmp[2] = riW3;
	iTmp[3] = riW4;
	iTmp[4] = riW5;
	iTmp[5] = 0;
	
	// erster Wrfel = grte Zahl (Sortieren)
	for (j=4; j!=0; j--)
	{
		for (i=0; i<=j; i++)
		{
			if (iTmp[i] < iTmp[i+1])
			{
				t = iTmp[i+1];
				iTmp [i+1] = iTmp[i];
				iTmp [i] = t;
			}
		}
	}

	// Werte sortiert zurckschreiben in Ausgangsvariable
	riW1 = iTmp[0];
	riW2 = iTmp[1];
	riW3 = iTmp[2];
	riW4 = iTmp[3];
	riW5 = iTmp[4];
}

BYTE CKniffelDlg::p1erbis6er(BYTE iWert)
{
	BYTE i = 0;
	BYTE e = 0;
	BYTE Punkte = 0;

	// wie oft ist [iWert] gewrfelt worden
	for (i = 0; i <= 4; i++)
	{
		if (iWuerfel[i] == iWert) e++;
	}

	Punkte = iWert*e;
	return Punkte;
}

BYTE CKniffelDlg::pPash(BYTE iAnzahl)
{
	BYTE i = 0;
	BYTE j = 0;
	BYTE t = 0;
	BYTE e = 0;
	BYTE Punkte=0;

	for	(j = 1; j<=6; j++)
	{
		for (i = 0; i <= 4; i++)		// wie oft ist [j] gewrfelt wurden
		{
			if (iWuerfel[i] == j) t++;
		}
		if (t >= iAnzahl)				// Anzahl der Wrfe >= der Vorgabe?
		{
			for (i=0; i <= 4; i++)		// alle Augen zusammenzhlen
			{
				e = e + iWuerfel[i];	
			}
			switch(iAnzahl)
			{
				case 3:
					Punkte = e;		// bei DreierPash alle Augen
					break;
				case 4:
					Punkte = e;		// bei ViererPash alle Augen
					break;
				case 5:
					Punkte = 50;	// bei Kniffel 50 
					break;
			}
		}
		t=0;
	}
	return Punkte;
}

BYTE CKniffelDlg::pFullhouse()
{
	bool t1=false;
	BYTE Punkte=0;
	BYTE i=0;
	BYTE tmpWuerfel[5];

	for (i=0;i<=4;i++)		// Werte zum bearbeiten zwischenspeichern
	{
		tmpWuerfel[i]=iWuerfel[i];
	}

	WOrdnen(tmpWuerfel[0],tmpWuerfel[1],tmpWuerfel[2],tmpWuerfel[3],tmpWuerfel[4]);	// Werte Ordnen
	

	// zwei gleiche und drei gleiche
	if((tmpWuerfel[0]+tmpWuerfel[1]+tmpWuerfel[2])/3 == tmpWuerfel[0])
	{
		if(((tmpWuerfel[3]+tmpWuerfel[4])/2 == tmpWuerfel[3]) && (tmpWuerfel[0] != 0)) Punkte= 25;
	}
	else
	{
		if(((tmpWuerfel[2]+tmpWuerfel[3]+tmpWuerfel[4])/3 == tmpWuerfel[2]) && (tmpWuerfel[0] != 0))
		{
			if((tmpWuerfel[0]+tmpWuerfel[1])/2 == tmpWuerfel[0]) Punkte= 25;
		}
	}

	return Punkte;
}

BYTE CKniffelDlg::pKstreet()
{
	BYTE i=0;
	BYTE j=0;
	bool t=false;
	bool bZahl[7];
	BYTE Punkte=0;

	// alles von bZahl auf false setzen
	for (i=0; i<=6; i++)
	{
		bZahl[i] = false;
	}

	// Zahlen bernehmen
	for (i=0; i<=4; i++)
	{
		bZahl[iWuerfel[i]]=true;
	}
	
	// vier aufeinander folgende Zahlen
	for (i=0; i<=3; i++)
	{
		if (bZahl[i] && bZahl[i+1] && bZahl[i+2] && bZahl[i+3])
		{
			t=true;
			i=4;		// aus der Schleife springen
		}
	}
	
	if (t) Punkte=30;

	return Punkte;
}

BYTE CKniffelDlg::pGstreet()
{
	BYTE i;
	BYTE Punkte=0;
	bool	t1=true;
	bool t2=true;
	BYTE tmpWuerfel[5];

	for (i=0;i<=4;i++)		// Werte zum bearbeiten zwischenspeichern
	{
		tmpWuerfel[i]=iWuerfel[i];
	}

	WOrdnen(tmpWuerfel[0],tmpWuerfel[1],tmpWuerfel[2],tmpWuerfel[3],tmpWuerfel[4]);	// Werte Ordnen
	
	for (i=0; i<=4; i++)
	{
		t1 = t1 && (tmpWuerfel[i] == 6-i);	// (6 bis 2)
		t2 = t2 && (tmpWuerfel[i] == 5-i);	// (5 bis 1)
	}

	if (t1 || t2)Punkte = 40;		// (2 bis 6) oder (1 bis 5)

	return Punkte;
}

BYTE CKniffelDlg::pChance()
{
	BYTE i = 0;
	BYTE Punkte = 0;

	// alle Augen zusammen zhlen
	for (i=0; i <= 4; i++)
	{
		Punkte = Punkte + iWuerfel[i];
	}
	
	return Punkte;
}

void CKniffelDlg::OnWuerfeln() 
{
		int i = 0;

	if (iWurf == 0)
	{
		// Schaltflschen freigeben
		GetDlgItem(IDC_WH1)->EnableWindow(true);
		GetDlgItem(IDC_WH2)->EnableWindow(true);
		GetDlgItem(IDC_WH3)->EnableWindow(true);
		GetDlgItem(IDC_WH4)->EnableWindow(true);
		GetDlgItem(IDC_WH5)->EnableWindow(true);
		OnWh();
	}
	
	if (iWurf < 3)
	{
		// Werte der Wrfel bestimmen
		for (i=0; i<=4; i++)
		{
			if (bWh[i] == false)
				iWuerfel[i] = 1+(rand()%6);
		}
		//iWuerfel[0] = 1;
		//iWuerfel[1] = 2;
		//iWuerfel[2] = 3;
		//iWuerfel[3] = 4;
		//iWuerfel[4] = 0;
		iWurf++;
	}
	if (iWurf == 3)
	{
		GetDlgItem(IDC_WUERFELN)->EnableWindow(false);

		// Halten der Wrfel zurcksetzten
		m_bWh1 = false;
		m_bWh2 = false;
		m_bWh3 = false;
		m_bWh4 = false;
		m_bWh5 = false;
		GetDlgItem(IDC_WH1)->EnableWindow(false);
		GetDlgItem(IDC_WH2)->EnableWindow(false);
		GetDlgItem(IDC_WH3)->EnableWindow(false);
		GetDlgItem(IDC_WH4)->EnableWindow(false);
		GetDlgItem(IDC_WH5)->EnableWindow(false);
		UpdateData(false);
		OnWh();
	}
	UpdateData(false);	
	Invalidate();
}

void CKniffelDlg::Wuerfel_anzeigen(CPaintDC *pdc)
{	
	BYTE i;
	BITMAP bm[5];
	CDC dcMem;

	// Gertekontext erzeugen, in den Bitmap geladen wird
	dcMem.CreateCompatibleDC(pdc);

	// Die 5 Wrfel anzeigen
	for (i=0;i<5;i++)
	{
		// Geladene Bitmaps hohlen
		m_bmpW[iWuerfel[i]].GetBitmap(&bm[i]);

		// Bitmap in den kompatiblen Gertekontext selectieren und in Dialogfeld kopieren
		dcMem.SelectObject(m_bmpW[iWuerfel[i]]);
		pdc->BitBlt(30+(80*i), 30, bm[i].bmWidth, bm[i].bmHeight, &dcMem, 0, 0,SRCCOPY);
	}
	// Gertekontext lschen
	DeleteDC(dcMem);
}

void CKniffelDlg::SPHilfe_anzeigen(CPaintDC *pdc)
{
	BYTE i=0;
	BYTE x=0;
	CString tmp="0";
	CFont m_fText;

	// Grund-Zeichenbereich festlegen
	CRect lRectFeld;
	lRectFeld.top = 203;
	lRectFeld.left = 110;
	lRectFeld.bottom = lRectFeld.top+27;
	lRectFeld.right = lRectFeld.left+40;

	//Text-Zeichenbereich festlegen
	CRect lRectText;
	lRectText.top = 206;
	lRectText.left = 110;
	lRectText.bottom = lRectText.top+27;
	lRectText.right = lRectText.left+40;


	// Schriftart festlegen
	m_fText.CreateFont(18,0,0,0, FW_SEMIBOLD,0,0,0, DEFAULT_CHARSET,OUT_CHARACTER_PRECIS,
		CLIP_CHARACTER_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, "Comic Sans MS");

	// Pinsel auswhlen
	CBrush lSolidBrush1(RGB(0,255,0));
	CBrush lSolidBrush2(RGB(255,255,0));
	pdc->SelectObject(&lSolidBrush2);

	//Schrift auswhlen
	pdc->SelectObject(&m_fText);
	pdc->SetTextColor(RGB(255,0,0));
	
	// linke Felder
	for (i=0;i<=5;i++)
	{
		if (m_bTaste[i])
		{
			tmp.Format("%d",p1erbis6er(i+1));
			x=(i*29);
			if (i > 3)x++;	// Ausgleich eines Grafikfehlers
			//HG
			lRectFeld.top= 203 + x;
			lRectFeld.bottom = 229 + x;
			pdc->Rectangle (lRectFeld);
			//Text
			lRectText.top = 206 + x;
			lRectText.bottom = 299 + x;
			pdc->SetBkColor(RGB(255,255,0));
			pdc->DrawText(tmp,lRectText,1);
		}
	}

	// rechte Felder
	lRectFeld.left = 256;
	lRectFeld.right = lRectFeld.left+40;
	lRectText.left = 256;
	lRectText.right = lRectFeld.left+40;
	for (i=0;i<=6;i++)
	{
		if (m_bTaste[6+i])
		{
			BYTE iPunkte=0;
			switch (i)
			{
				case 0:
					iPunkte = pPash(3);
					break;
				case 1:
					iPunkte = pPash(4);
					break;
				case 2:
					iPunkte = pFullhouse();
					break;
				case 3:
					iPunkte = pKstreet();
					break;
				case 4:
					iPunkte = pGstreet();
					break;
				case 5:
					iPunkte = pPash(5);
					break;
				case 6:
					iPunkte = pChance();
					break;
			}

			pdc->SelectObject(&lSolidBrush2);
			pdc->SetBkColor(RGB(255,255,0));
			if ((iPunkte>0)&&(i<6))
			{
				pdc->SelectObject(&lSolidBrush1);
				pdc->SetBkColor(RGB(0,255,0));
			}

			tmp.Format("%d",iPunkte);
			x=(i*29);
			if (i > 3)x++;	// Ausgleich eines Grafikfehlers
			//HG
			lRectFeld.top= 203 + x;
			lRectFeld.bottom = 229 + x;
			pdc->Rectangle (lRectFeld);
			//Text
			lRectText.top = 206 + x;
			lRectText.bottom = 299 + x;
			pdc->DrawText(tmp,lRectText,1);
		}
	}

}
