// KniffelDlg.h : Header-Datei
//

#if !defined(AFX_KNIFFELDLG_H__36930BF1_D63F_4867_870C_FD35333B55D5__INCLUDED_)
#define AFX_KNIFFELDLG_H__36930BF1_D63F_4867_870C_FD35333B55D5__INCLUDED_

#include "HscDlg.h"	// Hinzugefgt von der Klassenansicht
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CKniffelDlg Dialogfeld

class CKniffelDlg : public CDialog
{
// Konstruktion
public:
	HICON m_icoZahl[7];
	CKniffelDlg(CWnd* pParent = NULL);	// Standard-Konstruktor

// Dialogfelddaten
	//{{AFX_DATA(CKniffelDlg)
	enum { IDD = IDD_KNIFFEL_DIALOG };
	BYTE	m_i1er;
	BYTE	m_i2er;
	BYTE	m_i3er;
	BYTE	m_i3pash;
	BYTE	m_i4er;
	BYTE	m_i4pash;
	BYTE	m_i5er;
	BYTE	m_i6er;
	BYTE	m_iBonus;
	BYTE	m_iChance;
	BYTE	m_iFullhouse;
	int		m_iGesamt;
	BYTE	m_iGstreet;
	BYTE	m_iKniffel;
	BYTE	m_iKstreet;
	BYTE	m_iOben;
	BYTE	m_iUnten;
	BOOL	m_bWh1;
	BOOL	m_bWh2;
	BOOL	m_bWh3;
	BOOL	m_bWh4;
	BOOL	m_bWh5;
	BOOL	m_bSphilfe;
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CKniffelDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	HICON m_hIcon;

	// Generierte Message-Map-Funktionen
	//{{AFX_MSG(CKniffelDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnExit();
	afx_msg void OnHsc();
	afx_msg void OnSphilfe();
	afx_msg void OnNewgame();
	afx_msg void On1er();
	afx_msg void On2er();
	afx_msg void On3er();
	afx_msg void On4er();
	afx_msg void On5er();
	afx_msg void On6er();
	afx_msg void On3pash();
	afx_msg void On4pash();
	afx_msg void OnFullhouse();
	afx_msg void OnKstreet();
	afx_msg void OnGstreet();
	afx_msg void OnKniffel();
	afx_msg void OnChance();
	afx_msg void OnWh();
	afx_msg void OnWuerfeln();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	BOOL m_bTaste[13];
	void SPHilfe_anzeigen(CPaintDC *pdc);
	CBitmap m_bmpW[7];
	BYTE pChance();
	BYTE pGstreet();
	BYTE pKstreet();
	BYTE pFullhouse();
	BYTE pPash(BYTE iAnzahl);
	BYTE p1erbis6er(BYTE iWert);
	void WOrdnen(BYTE &riW1,BYTE &riW2,BYTE &riW3,BYTE &riW4,BYTE &riW5);
	void Wuerfel_anzeigen(CPaintDC *pdc);
	void PunkteAuszaehlen();
	BOOL bWh[5];
	BYTE iDurchgang;
	BYTE iWurf;
	BYTE iWuerfel[5];
	CHscDlg m_dlgHsc;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_KNIFFELDLG_H__36930BF1_D63F_4867_870C_FD35333B55D5__INCLUDED_)
